version: "3.4"

services:

  visualizer:
    image: dockersamples/visualizer:stable
    ports:
      - "8082:8080"
    stop_grace_period: 1m30s
    volumes:
      - "/var/run/docker.sock:/var/run/docker.sock"
    deploy:
      placement:
        constraints: [ node.role == manager ]

  portainer:
    image: portainer/portainer-ce
    command: -H tcp://tasks.agent:9001 --tlsskipverify
    ports:
      - "9000:9000"
      - "8000:8000"
    volumes:
      - portainer_data:/data
    networks:
      - agent_network
    deploy:
      mode: replicated
      replicas: 1
      placement:
        constraints: [ node.role == manager ]

  agent:
    image: portainer/agent
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock
      - /var/lib/docker/volumes:/var/lib/docker/volumes
    networks:
      - agent_network
    deploy:
      mode: global
      placement:
        constraints: [ node.platform.os == linux ]


  gateway:
    image: esteoan/cc-proiect-2:apigateway
    ports:
      - 3000:80
    secrets:
      - jwtKey
    environment:
      CARS_SERVICE_API_ROUTE: lab4-cluster_cars-service/api
      AUTHENTICATION_SERVICE_API_ROUTE: lab4-cluster_authentication-service/api
      NODE_ENV: development
    networks:
      - internal
    deploy:
      replicas: 2
      update_config:
        parallelism: 2
        delay:  10s
      restart_policy:
        condition:  on-failure

  authentication-service:
    image:  esteoan/cc-proiect-2:aut
    secrets:
      - jwtKey
    environment:
      IO_SERVICE_API_ROUTE: lab4-cluster_io-service/api
      NODE_ENV: development
    networks:
      - internal
      - authentication
  
  cars-service:
    image: esteoan/cc-proiect-2:books
    environment:
      IO_SERVICE_API_ROUTE: lab4-cluster_io-service/api
      NODE_ENV: development
    networks:
      - internal
      - cars
    deploy:
      replicas: 2
      update_config:
        parallelism: 2
        delay: 10s
      restart_policy:
        condition: on-failure
  
  io-service:
    image: esteoan/cc-proiect-2:io
    environment:
      PGUSER: admin
      PGPASSWORD: admin
      PGHOST: lab4-cluster_db
      PGPORT: 5432
      PGDATABASE: books
      NODE_ENV: development
    networks:
      - cars
      - database
      - authentication
    deploy:
      replicas: 2
      update_config:
        parallelism: 2
        delay: 10s
      restart_policy:
        condition: on-failure

  db:
    image: postgres:12
    environment:
      POSTGRES_DB: books
      POSTGRES_USER: admin
      POSTGRES_PASSWORD: admin
    volumes:
      - ./Database/init-db.sql:/docker-entrypoint-initdb.d/init-db.sql
      - lab4-db:/var/lib/postgresql/data
    networks:
      - database
      - database-admin
    deploy:
      placement:
        constraints: [node.role == manager]
      
  adminer:
    image: adminer
    ports:
      - 8080:8080
    networks:
      - database-admin
    depends_on:
      - db
    deploy:
      placement:
        constraints: [node.role == manager]

volumes:
  lab4-db:
  portainer_data:

networks:
  internal:
  cars:
  database:
  database-admin:
  authentication:
  agent_network:
    driver: overlay
    attachable: true

secrets:
  jwtKey:
    external: true